// ************************ jsForm generator
// formgen V. 0.2.8 17 March 2020
// free to use but no warranties
// El Condor - Condor Informatique - Turin
// ************************
if (typeof(window.$) != "function") var $ = function (id) {return document.getElementById(id);};  // wrap getElementById
formGen = function(idDiv,param) {
/* ************************* some functions *************************/
	var check = function(frm,widget) {	// can controls all form or only the widget
		if (typeof widget == "undefined") var widget = "";
		var controls = formGen[frm.fg_Store.value].controls
		var aErrors = [];
		for (var field in controls) {
			var widgetValue = (widget == "") ? frm[field].value : widget.value;
			if (widget != "" && widget.name != field) continue;
			var aItems = controls[field];
			for (k=0;k<aItems.length;k++) {
//				console.log(field+"\t"+aItems[k][0]+"\t"+aItems[k][1])
				var clr = "";
				if (/^\s*$/.test(widgetValue)) {
					if (/required/i.test(controls[field]))  clr = "red";
				} else {
					switch (aItems[k][0]) {
						case "MIN":
							if (parseFloat(widgetValue) < parseFloat(aItems[k][1])) clr = "red";
							break;			
						case "MAX":
							if (parseFloat(widgetValue) > parseFloat(aItems[k][1])) clr = "red";
							break;
						case "PATTERN":
							var regExpr = new RegExp(formGen.prototype.dropCommaSemicolon(aItems[k][1]));
							if (!regExpr.test(widgetValue)) clr = "red";
							break;
						case "MAIL":
							if (!/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(widgetValue)) clr = "red";
							break;
					}
				}
				if (clr != "") {
					aErrors[aErrors.length] = field+": "+aItems[k][0]+" "+aItems[k][3];					
					if (aItems[k][0] == "REQUIRED") break;
				}
			}
			frm[field].style.borderColor = clr;
		}
		return aErrors;
	};
	var storeDefaults = function(item,def) {	// used for store defaults
		if (!Array.isArray(item)) item = item.split(",");
		for (var j=0;j<item.length; j++) {
			var itemDef = item[j].split(/\s*=/);
			if (itemDef.length == 2) {def[itemDef[0]] = itemDef[1];};
		}
	}
	var createOptions = function(id,listItems) {	// lists and combos		
		var idFrm = jsForm[0]+id;
		if ($(idFrm) == null) return;
		var defaults = formGen[$(idFrm).form.fg_Store.value].defaults;
		var widgets = formGen[$(idFrm).form.fg_Store.value].widgets;
		var x = $(idFrm);
		if (widgets[idFrm][0] == "L") x = $(idFrm+"_List");
		x.innerHTML = ""
		aItems = formGen.prototype.splitKeyValue(listItems.split(","));	// clean list
		var opt = ""
		var group = "";
		for (k=0;k<aItems.length;k++) {
			var disabled = "";
			if (aItems[k][0] == "|") {
				disabled = " disabled style='font-weight:bold;font-style:italic'";
				group = aItems[k][1];
			}
			opt += "<option Value='" + aItems[k][0] + "'" + disabled + ">" + aItems[k][1] + "</option>"
			listGroups[jsForm[0]+id+aItems[k][0]] = group;
			if (typeof defaults[id] != "undefined") {
				if (aItems[k][1] == defaults[id]) defaults[id] = aItems[k][0];	// key if default supplied is value
				$(idFrm).value = defaults[id];
			} else $(idFrm).value = "";		
		}
		x.innerHTML = opt;
		if (typeof defaults[id] == "undefined") x.selectedIndex = -1
	}
	var addHidden = function(frm,name,value) {
		var hidden = document.createElement("input");
		hidden.setAttribute("type","hidden");
		hidden.setAttribute("name",name);
		if (typeof value != "undefined") hidden.setAttribute("value",value);
		frm.appendChild(hidden)
	}
	var	existsSubmitButton = function(aBtn) {	// checks if exists a submit button
		for (j in aBtn) {if (aBtn[j][0] == "BOTTOM") 
			if (j != "fg_Cancel" && j != "fg_Reset") return true}
		return false;
	};
	var genButton = function(name,btn) {
		if (btn[3] != "B" && btn[3] != "GB") return btn[4];
		var typeBtn = (btn[3] == "GB") ? "<input type='image' src='" + btn[2] + "' style='vertical-align:middle;'" 
			: "<input type='button' value='" + btn[2]+ "' name='" + name +"'";
		if (name != jsForm[0]+"fg_Reset") var eventBtn = " onClick='return formGen.prototype.handle(this.form,\""+name+"\""+((btn[4] == "")?"":","+btn[4])+")'"
		else var eventBtn = " onClick='formGen.prototype.setDefaults(this.form[\"fg_Store\"].value)'"
		titleBtn = " title='" + ((typeof btn[5] != "undefined") ? formGen.prototype.dropCommaSemicolon(btn[5]) : "") + "'";
		styleBtn = " class='fg_"+btn[3]+"utton'" + ((btn[6] != "") ? " style='width:" + btn[6] + "px'":"");
		idBtn = (name.substr((jsForm[0]).length,3) != "fg_") ? " id='" + name + "'":"";		// no ID for standard buttons
		return "\n" + typeBtn + eventBtn + styleBtn + idBtn + titleBtn + " />";
	};
	var log10 = val => Math.log(val) / Math.LN10;
/* ************************* end some functions *************************/
	if (typeof param == "undefined") var param = $(idDiv).innerHTML;
	if (param == "") {
		alert("No data!");
		return;
	}
	var singleName = ""	//	for unique combo
	var store = "fg_"+idDiv;		// must be here for output ID
	this.widgets = {};
	var jsForm = new Array("","","","","","","T","fg_Form");			// what function?
	function idNameSize(wdg) {
		var ctrl = "id='"+jsForm[0]+wdg[1] + "' name='"+wdg[1] + "'";
		if ("NNSNF".indexOf(typeWidget) == -1) ctrl += " size='" + +wdg[3] + "'"
		if (wdg[4] != "") ctrl += " placeholder=' " + wdg[4] + "'";	// hint
		return ctrl;
	};
	var llText = 50;		// limit from text and textarea
//	var alignRight = " style='text-align:right;padding-right:10px'";
	this.defaults = new(Array);
	this.events = new(Array);
	this.controls = {};				// controls
	var aLists = {};				// Lists and combos array
	var listGroups = new Array();	// Lists and combos group array
	var btnPosition = new Array();	// btnPosition field, button,...
	var wdg = (param.replace(/\n|\r/g,"")).split(";");
	var convertType = {"TEXT": "T", "PSW": "P", "LIST": "L", "FILE":"F","SLIDER":"S","RDB":"R","RV":"R",
				"COMMENT": "C","CONTROL": "CHECK","REQUIRED":"REQ","IB":"GB","HIDDEN":"H","DEFAULTS":"DEFAULT"}
// ****************** lacks of Date and Time
	var types = {"T": "T","N": "T","NS": "T","NF": "T","P": "T","L": "T","F": "FT","S": "T","CMB": "C","CKL":"T",
				"C":"","U":"","H":"","B":"B","GB":"GB","R":"C","CKB":"T","DATE":"","TIME":""}
	var lengths = {S:150,NF:9,NS:7,N:6}	// if no length is provided is 20 characters
	var typeForm = "";		// typeForm: T = text, B = buttons, C = combo box or RadioButtons
// ******************************* start build *************************	
	var i,j,k;
	var ajaxEvent = 0;
	var aButtons = {};
//	for (let i=0;i<wdg.length; i++) console.log(i +"\t"+ wdg[i])
	for (let i=0;i<wdg.length; i++) {
		var field = wdg[i].split(",");
		if (field[0].substr(0,2) == "//") continue		// comment
		if (field[0] == "RV") field[3] = -1				// for vertical Radio buttons
		while (field.length < 7) field[field.length] = "";
		field[0] = field[0].toUpperCase();		// upper-case control name
		if (typeof convertType[field[0]] != "undefined") {field[0]  = convertType[field[0]]}
		if (field[0] == "FORM") {
			jsForm = field.slice(1,8);
			jsForm.push('fg_Form');
			if (jsForm[0] != "") jsForm[7] = jsForm[0];
		} else if (field[0] == "DEFAULT") {
			storeDefaults(field.slice(1),this.defaults);
		} else if (field[0] == "EVENT") {
			this.events[field[1]] = field.slice(2);
		} else if (field[0] == "CHECK") {
			formGen.prototype.addControl(this.controls,field[1],field.slice(2))
		} else if (field[0] == "REQ") {
			for (var j=1;j<field.length; j++) formGen.prototype.addControl(this.controls,field[j],Array("required"));
		} else if (field[0] == "AFTER" || field[0] == "BELOW") {
			btnPosition[jsForm[0]+field[1]] = field;
		} else if (field[0] == "GET") {				// call Ajax data
			if (field[1] != "*") formGen.prototype.ajax(field[2],field[1],function(c,fld){ajaxEvent--;aLists[fld] = c});	// get combo items
			else {
				formGen.prototype.ajax(field[2],"",function(c){
					ajaxEvent--;storeDefaults(c,formGen[store]["defaults"]);formGen.prototype.setDefaults(store)
					})
			}
			ajaxEvent++;
		} else if (field[0] != "") {
			// normalization of parameters
			if (field[1] == "") field[1] = "fg_" + i;	// generated name
			var IDName = jsForm[0]+field[1];
			if (field[2] == "") field[2] = field[1];	// label
			if  (field[3] == "" && " GBR".search(field[0]) == -1) {		// if lacks length
				if (typeof lengths[field[0]] != "undefined") {field[3]  = lengths[field[0]]}
			}
			if (field[0] == "S") {	// slider range and step
				if (field[4] == "") {field[4] = "0";field[5] = "100";field[6] = "1";}
				var min = Number(field[4]);
				var max = Number(field[5]);
				var delta = Math.abs(max-min);
				if (field[6] == "") 
					field[6] = toString(1/(Math.pow(10,((Math.floor(log10(delta)-2) < 1)?-Math.floor(log10(delta)-2):0))));
				this.defaults[field[1]] = (max < min) ? min : min + 0.5 * (max - min)
			} else if (field[0].substr(0,2) == "NF") {	// floating point number
				field[6] = (Number(field[0].substr(2)) != NaN)? Number(field[0].substr(2)):0;
				field[0] = "NF";
			}
			this.widgets[IDName] = field;
			if (field[0] == "B" || field[0] == "GB") {
			aButtons[IDName] = Array("BOTTOM","",field[2],field[0],field[4],field[5],field[3])			
			} else {
				if (typeof types[field[0]] != "undefined") {
					typeForm += types[field[0]];		// for find the buttons to expose
				} else {
					field[2] = field[0] + " Unknown type"
					field[0] = "C"
				}				
			}
		}
	}
// control correctness AFTER,BELOW
	for (k in btnPosition) {
		if (typeof this.widgets[k] == "undefined") {
			alert("AFTER, BELOW: control "+k.substr(2)+" not exists");
		} else {
			for (j=2;j< btnPosition[k].length;j++) {
				if (btnPosition[k][j] != "") {
					IDName = jsForm[0]+btnPosition[k][j];
					if (typeof this.widgets[IDName] == "undefined") alert("AFTER, BELOW: control "+btnPosition[k][j]+ " not exists"); 
					else {						
						if (typeof aButtons[IDName] == "undefined") {	// it is not a button, for now check box
							 aButtons[IDName] = [btnPosition[k][0],btnPosition[k][1],this.widgets[IDName][2],this.widgets[IDName][0],""];
//							if (this.widgets[IDName][0] != "CKB") alert("AFTER, BELOW only Buttons or Check boxes");
//							else aButtons[IDName] = [btnPosition[k][0],btnPosition[k][1],this.widgets[IDName][2],this.widgets[IDName][0],""];
						} else {
							aButtons[IDName][0] = btnPosition[k][0];
							aButtons[IDName][1] = btnPosition[k][1];
						}
					}
				}
			}
		}
	}
	var formID = jsForm[7];
	frm = "<FORM id='"+jsForm[7]+"' method='POST'" + ((jsForm[2] != "" && jsForm[3] == "")?" action='"+jsForm[2]+"'":"") + " >";
	frm += "<table class='fg_Table'>";
	if (jsForm[1] != "") frm += "<tr><th class='fg_Title' colspan=3>" + jsForm[1] + "</th></tr>";
	var aWidgets = Object.keys(this.widgets);
	for (let i =0;i<aWidgets.length;i++) {
		field = this.widgets[aWidgets[i]];
		typeWidget = field[0];
		var IDName = jsForm[0]+field[1];		// id = formId+Name
		if (typeWidget == "C") {
			frm += "\n<tr><td colspan=3 id='" +IDName + "'>"+field[2];	// comment field
			continue;
		}
		if (typeWidget == "H") {
			this.defaults[field[1]] = field[4];
			frm += "\n<input type='hidden' id='" + IDName + "' name='"+field[1] +"' value='"+ field[4] +"'>";	// hidden field
			continue;
		}
		if (typeWidget == "B") continue;
		if (typeof aButtons[IDName] == "undefined") frm += "\n<tr><td class='fg_label'>"+field[2]+"<td>";	// not after	
		if (typeWidget == "CKB") {								// Check box *******************
			var ckb = "<input type='checkbox' id='"+IDName+"' name='"+field[1]+"' value='on' /> " + field[4];
			if (typeof aButtons[IDName] == "undefined") frm += ckb;
			else {aButtons[IDName][4] = field[2]+ckb;}		// this is an after
		} else if (typeWidget == "CKL") {						// Check list ******************
			var aItems = formGen.prototype.splitKeyValue(field.slice(4));
			frm += "<input type='hidden' id='"+IDName + "' name='"+field[1]+"'/>"
			var checked = 0;
			for (var ck=0;ck<aItems.length;ck++) {
				this.widgets[jsForm[0]+aItems[ck][0]] = Array("CKB",aItems[ck][0]);	// complete widgets
				var ckb = "<input type='checkbox' onChange='formGen.prototype.updCountCheckList(\""+IDName+"\",this.checked)'"
				+ " id='"+jsForm[0]+aItems[ck][0]+"' name='"+aItems[ck][0]+"' value='on' /> " + aItems[ck][1];
				if (ck < aItems.length-1) ckb += "<br>";
				frm += ckb;
				if (typeof this.defaults[aItems[ck][0]] != "undefined") checked++;
			}
			this.defaults[field[1]] = checked;
		} else if (typeWidget == "CMB" || typeWidget == "L") {	// combo and List **************
			singleName = field[1];
			aLists[field[1]] = (field.slice(4)).join(",");
			if (typeWidget == "CMB") {
				this.events["fg_"+singleName] = Array("change","formGen.prototype.handleEventOptions");				
				frm += "<input type='hidden' name='"+field[1] +"_Group' id='"+IDName + "_Group'/>"
				frm += "<SELECT id='"+IDName + "' name='"+field[1] +"'></SELECT>";
			} else {
				frm += "<input name='" + field[1] + "' id='" + IDName + "' list='" + IDName + "_List'/>"
				+ "<span style='margin-left:-11px;margin-right:5px;cursor:pointer' title='Erase'>&#x2718;</span>"
				+ "<datalist name='" + field[1] + "' id='" + IDName + "_List'></datalist>"
			}
		} else if (typeWidget == "S") {							// ***************** Slider *********************
			frm += "\n<input type=range id='"+IDName + "' name='"+field[1] +"' min='"+field[4]+"' max='"+field[5] + "'"
			if (field[6] != 0) frm += " step='" + field[6] + "'";
			frm += " onChange='$(\"s_\"+this.id).innerHTML = this.value'";
			frm += " style='width:" + field[3] + "px;vertical-align: middle'/>";
			frm += "<span id='s_" + IDName +"' style='display:inline-block;width:3em;padding-left:5px;vertical-align:middle'></span>";
		} else if (typeWidget == "F") {					// File (before text!!! *************
			var accept = (field[4] != "") ? "accept='"+(field.slice(4)).join()+"' ":"";
			frm += "<input type=file " + accept + idNameSize(field) + "/>";
			jsForm[6] = "F";
		} else if (" TNSNF".indexOf(typeWidget) > 0) {		// T, U, N, NS, NF **************
			if (field[3] > llText) {
				frm += "<textarea cols=50 rows="+Math.ceil(field[3] / llText);
				frm += " id='"+IDName + "' name='"+field[1] +"' ></textarea>";
			} else {
				var txt = "";
				if (" NSNF".indexOf(typeWidget) > 0) {
					txt += "\n<input type='number' " + idNameSize(field) + " style='text-align:right;width:" + field[3] +"em'";
					if (typeWidget == "NF") {
						txt += " inputmode='decimal' step='" + 1/Math.pow(10,Number(field[6])) + "'";
					} else {
						txt += " inputmode='numeric'";
						if (typeWidget == "N") {
							txt += " min='0'";
							formGen.prototype.addControl(this.controls,field[1],Array("Min=0"));
						}
					}
					txt += "/>";
				} else {
					txt += "<input type='text' " + idNameSize(field) + "/>";
					txt += "<span style='margin-left:-11px;margin-right:5px;cursor:pointer' title='Erase'>&#x2718;</span>";
				}
				txt += field[5];				
				if (typeof aButtons[IDName] == "undefined") frm += txt;
				else {aButtons[IDName][4] = "<span class='fg_label'>"+field[2]+"</span>"+txt;}		// this is an after
			}
		} else if (typeWidget == "U") {		// *************** not modifiable ***************		
				if (field[4] != "") this.defaults[field[1]] = field[4];		// field value
				frm += "\n<input type='text' id='"+IDName + "' name='"+field[1] +"' value='"+ field[4] +"' readonly/>";
		} else if (typeWidget == "P") {					// Password
			frm += "<input type=password " + idNameSize(field) + "/>"
				+ "<span style='margin-left:-11px;margin-right:5px;cursor:pointer' title='Erase'>&#x2718;</span>" + field[5];

		} else if (typeWidget == "R") {		// *************** Radio buttons *******************
			singleName = field[1];		// for possibly single				
			var aItems = formGen.prototype.splitKeyValue(field.slice(4));
			var evnt = ""
			if (typeof this.events[field[1]] != "undefined") {
				evnt = " on"+this.events[field[1]][0]+"='"+this.events[field[1]][1]+"(event)'";
				delete this.events[field[1]];
			}
			for (var ck=0;ck<aItems.length;ck++) {
				frm += "\n<input type='radio' name='"+field[1]+"' id='"+IDName+(ck) + "' value='"+ aItems[ck][0] + "'" +evnt +"/>";
				frm += ((Number(field[3]) > 0) ? "<span style='display:inline-block;width:" + (field[3]) + "px'>" + aItems[ck][1] + "</span>" : aItems[ck][1]);
				if (Number(field[3]) == -1) frm +="<br>";	// vertical radio buttons
				if (typeof this.defaults[field[1]] != "undefined") {
					if (aItems[ck][0] == this.defaults[field[1]] || aItems[ck][1] == this.defaults[field[1]]) this.defaults[field[1]] = ck;
				}
			}
			frm += "\n<input type='radio' name='" + field[1] + "' id='" + IDName + "' value='' CHECKED style='display:none'>";
		} else if (typeWidget == "DATE") {
			frm += "<input type='date' name='" + field[1] + "' id='" + IDName + "'>";
		} else {
		}
		if (typeof btnPosition[IDName] != "undefined") {	// for buttons below or after
			var whereButton = (btnPosition[IDName][0] == "BELOW")?"div":"span";
			frm += "<"+whereButton+" style='text-align:center' id='"+store+field[1]+btnPosition[IDName][0]+"'></"+whereButton+">";
		}			
	}
	if (typeForm != "C") {			// if no only list type widget
		frm += "<tr><td colspan=2 style='text-align:center'>";
		frm += "<div id='"+store+"BOTTOM'></div>";
	}
	frm += '</Table></FORM>';
	$(idDiv).innerHTML = frm;
//	 add hidden	*********************
	addHidden($(jsForm[7]),'fg_Button')
	addHidden($(jsForm[7]),'fg_Store',store)
	// add buttons	*********************
	if (typeForm != "C") {		// there are need of buttons
		if (!existsSubmitButton(aButtons)) {aButtons[jsForm[0]+"fg_Ok"] = Array("BOTTOM","","Ok","B","","","")}
		if (typeof aButtons[jsForm[0]+"fg_Reset"] == "undefined") {aButtons[jsForm[0]+"fg_Reset"] = Array("BOTTOM","","Reset","B","","","")}
		if (typeof aButtons[jsForm[0]+"fg_Cancel"] == "undefined") {
			if (jsForm[4].toLowerCase() != "static") aButtons[jsForm[0]+"fg_Cancel"] = Array("BOTTOM","","Cancel","B","","","")	// no cancel button if the form is static
		}
		for (j in aButtons) {
			$(store+aButtons[j][1]+aButtons[j][0]).innerHTML += genButton(j,aButtons[j]);
		}
	} else 	{		
		if (field[0] == "R") {
				var rdbs = document.getElementsByName(field[1]);
				for (i=0;i<rdbs.length-1;i++) {
					this.events[singleName+(i)] = Array("click","formGen.prototype.handleSingleRDB");
				}				
			} else {
				this.events[singleName] = Array("change","formGen.prototype.handleSingle");
			}
	}
	// add controls	*********************
	for (field in this.controls) {
		if (typeof this.widgets[jsForm[0]+field] == "undefined") {
			alert ("Control " + field + " not exists")
			delete this.controls[field];
		} else {
			$(jsForm[0]+field).onblur = function(){check(this.form,this)};
		}
	}
    if (jsForm[0] != "") {
			$(jsForm[0]).addEventListener('keypress', function(event) {		// prevent enter
            if (event.keyCode == 13) {event.preventDefault();}
        });
	}
	// store variables
	formGen[store] = {"jsForm": jsForm,
			"defaults": this.defaults, 
			"widgets": this.widgets, 
			"controls": this.controls,
			"listGroups": listGroups,
			"aLists": aLists,
			"createOptions":createOptions,
			"check":check};
	// add events	*************************************************
	for (let name in this.events) {
		var field = (name.substr(0,3) == "fg_") ? name.substr(3) : name;
/* 		if (typeof this.widgets[jsForm[0]+field] == "undefined") {
			alert (field + " not exists")
		} else {
*/			
		$(jsForm[0]+field).addEventListener(this.events[name][0],eval(this.events[name][1]))
//		}
	}
	$(formID).addEventListener("click",formGen.prototype.handleClick);	// event for erase text fields
	var handleInterval = setInterval(waitAjax,500)
/* 	for (var field in this.controls) {
		console.log("*** "+ field+" ***")
		console.log(this.controls[field])
	}	
 */	
	return {
		createOptions:createOptions,
		storeDefaults:storeDefaults,
		check:check
		}
	function waitAjax() {	// this function updates combos and sets defaults	
		if (typeof waitAjax["t"] == "undefined") waitAjax["t"] = 0
		waitAjax["t"] += 500
		if (ajaxEvent == 0) {
			clearInterval(handleInterval);
			for (i in aLists) {		// add contents to lists and combos	*********************
				createOptions(i,aLists[i]);
			}
			formGen.prototype.setDefaults(store);		// set defaults			
		} else {
			if (waitAjax["t"] > 5000) {
				clearInterval(handleInterval);
				alert("Ajax timeout");
			}
		}
	}
};
formGen.prototype.handleEventOptions = function (event) {
	formGen.prototype.handleOptions(event.target);}
formGen.prototype.handleOptions = function (opt) {
	var listGroups = formGen[opt.form.fg_Store.value]["listGroups"]
	$(opt.id + "_Group").value = listGroups[opt.id + opt.options[opt.selectedIndex].value];
}
formGen.prototype.handleSingleRDB = function (event) {	// for capture single radio button
	frm = event.target.form.id;
	formGen.prototype.handle($(frm),event.target.id);
}
formGen.prototype.handleSingle = function (event) {	// for capture single combo
	frm = event.target.form.id;
	var opt = $(event.target.id);
	formGen.prototype.handleOptions(opt);		// capture group name
	formGen.prototype.handle($(frm),event.target.id);
}
formGen.prototype.handle = function (frm,button,customHandler) {	// send request
	if (typeof customHandler != "undefined") {		// button handled
		return customHandler(frm);
	}
	var store = frm.fg_Store.value;
	var jsForm = formGen[store]["jsForm"];
	if (button.substr(0,jsForm[0].length) == jsForm[0]) button = button.substr(jsForm[0].length)
	frm.fg_Button.value = button;
	var formParms ={"URI":jsForm[2],"ajaxFunction":jsForm[3],"action": jsForm[4].toLowerCase(),
					"erase":false,"container":store.substr(3),"store":store,"target":jsForm[5].toLowerCase()}
	if (button == "fg_Cancel") formParms.erase = true;
	else {
		var aErrors = formGen[store]["check"](frm);		// data control ******************
		if (aErrors.length > 0) return alert("Errors:\n"+aErrors.join("\n"));
		if (formParms.target == "" || formsParms.target == "_self") {
			if(formParms.action != "reset" && formParms.action != "static") formParms.erase = true;
		}
	}
	if (formParms.URI != "" && formParms.ajaxFunction == "") {		// only URI
		if (button != "fg_Cancel") {
			if (jsForm[6].indexOf("F") > -1) frm.encoding = "multipart/form-data";	// for files
			frm.action = formParms.URI;
			if (formParms.target != "") frm.target = formParms.target == "newwindow"?"_blank":formParms.target;
			frm.submit();
		}
		if (formParms.erase) $(formParms.container).innerHTML = "";
		else {
			if(formParms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(store)},100);
		}
	} else if (formParms.URI == "" && formParms.ajaxFunction != "") {		// only call function
		if (button == "fg_Cancel") {
			var form = document.createElement("form");
			form.setAttribute("id",frm.id);
			form.setAttribute("method",frm.method);
			$(formParms.container).replaceChild(form,frm);
			frm["fg_Button"].value = "fg_Cancel";
		}
		window[jsForm[3]](frm);
		if (formParms.erase) $(formParms.container).innerHTML = "";
		else {
			if(formParms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(store)},100);
		}
	} else if (formParms.URI != "" && formParms.ajaxFunction != "") {		// call Ajax receive in function
		if (jsForm[6].indexOf("F") > -1) frm.encoding = "multipart/form-data";	// for files
		if (button != "fg_Cancel") {
			var form = document.createElement("form");
			form.setAttribute("id",frm.id);
			form.setAttribute("method",frm.method);
			$(formParms.container).replaceChild(form,frm);
			frm["fg_Button"].value = "fg_Cancel";
		}
		var handleAjax = function(response,frm,handler2,parms) {	// handler(ajx.responseText,frm,handler2,frm,parms)
			handler2(response,frm);
			if (parms.erase) $(formParms.container).innerHTML = "";
			else {
				if(parms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(store)},100);
			}		
		}
		formGen.prototype.ajax(jsForm[2],frm,handleAjax,window[formParms.ajaxFunction],formParms);

	} else {
		if (button == "fg_Cancel") {
			var form = document.createElement("form");
			form.setAttribute("id",frm.id);
			form.setAttribute("method",frm.method);
			$(formParms.container).replaceChild(form,frm);
			frm["fg_Button"].value = "fg_Cancel";
		}
		alert(formGen.prototype.getData(formGen[store],button));
		if (formParms.erase) $(formParms.container).innerHTML = "";
		else {
			if(formParms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(store)},100);
		}
	}
}
formGen.prototype.dropCommaSemicolon = function(s) { // deMask , ; = &
	 return s.replace(/\\x2C|\\x3B|\\x3D|\\x26/gi,function(s){return String.fromCharCode(parseInt("0"+s.substr(1)))});
};
formGen.prototype.splitKeyValue = function(aSplit) {	// return array of items
	var sep = "=";
	var aRet = new Array();
	for (var i in aSplit) {
		if (/^\s*$/.test(aSplit[i])) aSplit[i] = " "+sep+" "		// test for empty
		if (aSplit[i].indexOf(sep) < 0) aSplit[i] = aSplit[i] + sep + aSplit[i];
		var a = aSplit[i].split(sep)
		if (a[0] != " ") aRet[aRet.length] = [a[0],formGen.prototype.dropCommaSemicolon(a[1])];
	}
	return aRet;
}
formGen.prototype.ajax = function(url,frm,handler,handler2,parms) {
	var data = (typeof(frm) == "string")? "" :new FormData(frm);
	var ajx = new XMLHttpRequest();
	ajx.onreadystatechange = function(){
	if (ajx.readyState == 4) {
		if (ajx.status == 200) {
			if(typeof handler2 != "undefined") return handler(ajx.responseText,frm,handler2,frm,parms)
			else return handler(ajx.responseText,frm);
		}		// the second parameter is data itself
			alert("Error: " + ajx.status + ": " + ajx.statusText);
		}
	}
	ajx.open("POST", url, true)
	ajx.send(data);
}
formGen.prototype.getData = function(storeStruct,button) {
	var widgets = storeStruct.widgets;
	var jsForm = storeStruct["jsForm"];
	var frm = $(jsForm[7]);
	var jsonObj = {};
	if (typeof button != "undefined") jsonObj["fg_Button"] = button;
	var names = frm.getElementsByTagName("input");		// all input tags
	for(let i=0;i < names.length;i++) {
		if (names[i].type == "checkbox") {
			jsonObj[names[i].name] = (names[i].checked)?names[i].value:"";
		}
	}	
	for (i in widgets) {
		var field = widgets[i];
		if (typeof frm[field[1]] != "undefined") {
			var widgetValue = frm[field[1]].value;
			if (field[0] == "CKB") {
				if (!frm[field[1]].checked) widgetValue = "";
			}
			else if (field[0] == "CMB") {
				jsonObj[field[1]+"_Group"] = frm[field[1]+"_Group"].value;
			}
			if (k = " *N*NS*NF*S".indexOf("*"+field[0]),k > 0) widgetValue = (widgetValue != "")?Number(widgetValue):0
			jsonObj[field[1]] = widgetValue;		
		}
	}
	return JSON.stringify(jsonObj);
}
formGen.prototype.setDefaults = function(storeStruct,widget) {
	var defaults = formGen[storeStruct].defaults;
	var widgets = formGen[storeStruct].widgets;
	var jsForm = formGen[storeStruct]["jsForm"];
	var aLists = formGen[storeStruct]["aLists"];
	for (i in widgets) {
		var field = widgets[i];
		var value = "";
		if (widget != field[1] && typeof widget != "undefined") continue;
		if (typeof defaults[field[1]] != "undefined") value = defaults[field[1]];
		var id = jsForm[0]+field[1];	// the name of control
		if (field[0] == "CKB") {
			if (value.toLowerCase() == "on" || value.toLowerCase() == "checked") $(id).checked = true;
			else $(id).checked = false;
		} else if (field[0] == "CKL") {
			$(id).value = value;
		} else if (field[0] == "S") {
			if (value != "") $(id).value = value;
			$("s_"+id).innerHTML =  value;	// $(id).value;
		} else if (field[0] == "DATE") {
			if (value.toLowerCase() == "today") {
				var d = new Date();
				$(id).value = d.getFullYear() + "-" + ('0' + (d.getMonth() + 1)).slice(-2) + "-" + ('0' + d.getDate()).slice(-2);
			}
		} else if (field[0] == "B" || field[0] == "GB") {
			if (value.toLowerCase() == "off") $(id).disabled = true;
		} else if (field[0] == "R") {
			$(id+value).checked = true;
		} else if (field[0] == "CMB" || field[0] == "L") {
			formGen[storeStruct]["createOptions"](id,aLists[field[1]])
			$(id).value = formGen.prototype.dropCommaSemicolon(value);
			if ($(id).selectedIndex > -1) formGen.prototype.handleOptions($(id));
		} else {
			if ($(id) != null) {
				$(id).value = formGen.prototype.dropCommaSemicolon(value);
			}			
		}
	}
}
formGen.prototype.addControl = function(controls,name,control) {
	if (name == "") return;
	if (typeof this.operands == "undefined") this.operands = ["MIN","MAX","MAIL","PATTERN","REQUIRED"];
	if (typeof controls[name] == "undefined") a = Array()
	else a = controls[name];			
	for (var i=0;i<control.length;i++) {
		if (control[i] != "") {
			var aItems = control[i].split("=");
			aItems.push("","","");
			aItems[2] = "=";
			if (this.operands.indexOf(aItems[0].toUpperCase()) == -1) {	// can be a signal error
				if (a.length > 0) {
					a[a.length-1][3] = control[i];
				}
			} else {
				aItems[0] = aItems[0].toUpperCase();
				a[a.length] = aItems;				
			}
		}
	}
	controls[name] = a;
//	controls[name] = a[0].sort(function(a,b) {if (b.toLowerCase() == "required") return 1; else return 0;});
}
formGen.prototype.handleClick = function(e) {
	var targ;
	if (!e) var e = window.event;
	if (e.target) targ = e.target;
	else if (e.srcElement) targ = e.srcElement;
	if (targ.nodeType == 3) targ = targ.parentNode; // defeat Safari bug
	if (targ.innerHTML == "\u2718" && targ.localName == "span") {	// Unicode delete
		var store = targ.previousSibling.form.fg_Store.value;
		formGen.prototype.setDefaults(store,targ.previousSibling.name);
	}
}
formGen.prototype.updCountCheckList = function(id,checked) {
		$(id).value = Number($(id).value) + (checked?1:-1)
}